SetOptions[LinearProgramming, Method -> "CLP"];

minimalMonomialMapG[deg_] :=
 Module[{b, c, i, j, poly, cpolys1, bvars, cvars,
    varpairs, cn, constraints, counter = 0, stack, soln, solns = {},
   cutvars, maxval, badpos, lmax, varvals, val, eps = 10^(-7),
   eps2 = 10^(-2), allvars, dim = (deg + 3)/2, osoln, posvars},
  poly = Sum[c[i, j]*x^i*y^j, {i, 0, deg}, {j, 0, deg - i}] - 1;
  cpolys1 = CoefficientList[poly /. y -> 1 - x, x];
  cvars = Variables[cpolys1];
  bvars = cvars /. c -> b;
  varpairs = Transpose[{bvars, cvars}];
  cn[1] = Map[0 <= # <= 1 &, bvars];
  cn[2] =
   Map[Min[Table[
         Binomial[deg, #[[1, 1]] + j]/
          Binomial[deg - (#[[1, 1]] + #[[1, 2]]), j], {j, 0,
          deg - (#[[1, 1]] + #[[1, 2]])}]]*#[[1]] >= #[[2]] &,
    varpairs];
  cn[3] = Map[# >= 0 &, cvars];
  cn[4] =
   Flatten[Table[
     b[i, j] + b[i, j + 1] <= 1, {i, 1, deg - 1}, {j, 1,
      deg - i - 1}]];
  cn[5] = Sum[
     c[i, j] - c[j, i], {i, 0, Floor[deg/2]}, {j, i + 1, deg - i}] <=
    0;
  cn[6] = Sum[b[i, deg - i - 1], {i, 1, deg - 2}] >= 1;
  cn[7] = Sum[b[i, deg - 2*i], {i, 1, (deg - 1)/2}] <= dim - 3;
  cn[8] = Sum[b[deg - 2*i, i], {i, 1, (deg - 1)/2}] <= dim - 3;
  Quiet[osoln =
    First[Solve[
      Flatten[{Thread[cpolys1 == 0],
        c[deg, 0] == 1, Total[bvars] == dim, c[0, deg] == 1,
        b[deg, 0] == 1, b[0, deg] == 1,
        Table[{b[j, deg - 1 - j] == 0, c[j, deg - 1 - j] == 0}, {j, 2,
           deg - 2, 2}],
        Table[{c[j, 0] == 0, c[0, j] == 0, b[j, 0] == 0,
          b[0, j] == 0}, {j, deg - 1}],
        Table[{c[j, deg - j] == 0, b[j, deg - j] == 0}, {j,
          deg - 1}]}]]]];
  constraints = Flatten[Array[cn, 8]];
  constraints = (constraints /. osoln) /. True :> Sequence[];
  allvars = Flatten[Variables[{bvars, cvars} /. osoln]];
  bvars =
   Reverse[Sort[Variables[bvars /. osoln],
     Total[#1] <= Total[#2] &]];
  stack = {Union[constraints], {}};
 (*main branching loop*)
  While[stack =!= {}, constraints = First[stack];
   stack = Last[stack];
   counter++;
   cutvars =
    Sum[bvars[[Mod[3*counter + j, Length[bvars], 1]]], {j, 0,
      2*deg - 4}];
   Quiet[
    soln = NMaximize[{(-1)^counter*cutvars, constraints}, allvars]];
   If[! FreeQ[soln, Indeterminate], Continue[]];
   {maxval, soln} = soln;
   varvals = Chop[bvars /. soln];
   badpos = 0;
   lmax = 0;
   Do[If[(val = Abs[varvals[[j]] - Round[varvals[[j]]]]) >= eps,
     lmax = val; badpos = j; Break[]], {j, Length[bvars]}];
   If[Mod[counter, 100] == 0, Print[{counter, badpos, lmax}]];
   If[badpos == 0,
    posvars = Extract[bvars, Position[varvals, aa_ /; aa >= eps]];
    Do[stack = {Join[constraints,
         Table[posvars[[i]] == 1, {i, j - 1}], {posvars[[j]] == 0}],
        stack};, {j, Length[posvars]}];
    soln =
     soln /. aa_Real :> Rationalize[Chop[aa, 10^(-8)], 10^(-5)];
    solns = Append[solns, (poly /. osoln) /. soln];
    ,(*else*)
    If[EvenQ[counter] && maxval < Ceiling[maxval] - eps2,
     constraints = Append[constraints, cutvars <= Floor[maxval]]];
    If[OddQ[counter] && -maxval > Floor[maxval] + eps2,
     constraints = Append[constraints, cutvars >= Ceiling[-maxval]]];
    stack = {Join[constraints, {bvars[[badpos]] == 1}], stack};
    stack = {Join[
       constraints, {bvars[[badpos]] ==
         0, (Apply[c, bvars[[badpos]]] /. osoln) == 0}], stack};];];
  {counter, solns /. osoln}]
